<template>
  <v-dialog v-model="dialog" persistent max-width="50%">
    <v-card>
      <v-card-title>
        <span v-text="title" />
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="6" v-if="isEdit">
              <v-text-field label="Witel ID*" v-model="witel.id" required readonly />
            </v-col>
            <v-col cols="6">
              <v-select
                  :disabled="statusProgress"
                  v-model="witel.regional.id"
                  :items="regionals"
                  item-text="nama"
                  item-value="id"
                  label="Pilih Regional"
              >
              </v-select>
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="6">
              <v-text-field label="Witel Alias*" v-model="witel.alias" :disabled="statusProgress" required />
            </v-col>
            <v-col cols="6">
              <v-text-field label="Witel Nama*" v-model="witel.nama" :disabled="statusProgress" required />
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
        <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
        <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
      </v-card-actions>
    </v-card>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-dialog>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import witelService from "../service/WitelService";
import regionalService from "../service/RegionalService";

export default {
  name: "WitelForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      regionals: [],
      witel: {
        id: '0',
        alias: null,
        nama: null,
        regional: {
          id: null
        }
      },
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
      this.retrieveRegional()
    },
    doEdit(id, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.retrieveWitel(id)
    },
    doReset() {
      this.witel.id = '0'
      this.witel.alias = null
      this.witel.nama = null
      this.witel.regional.id = null
    },
    async doSaveOrUpdate() {
      if (!this.validation()) {
        return
      }
      let data = {
        id: this.witel.id,
        alias: this.witel.alias,
        nama: this.witel.nama,
        regional: {
          id: this.witel.regional.id
        }
      }
      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(data)
      } else {
        await this.doUpdate(data.id, data)
      }
      this.statusProgress = false
    },
    doSave(data) {
      witelService.store(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    doUpdate(id, data) {
      witelService.update(id, data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
            }
            this.dialog = false
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    async retrieveRegional() {
      this.statusProgress = true
      await regionalService.getAll()
          .then(res => {
            let regionals = res.data.data
            for (let i in regionals) {
              let reg = {
                id: regionals[i].id,
                nama: regionals[i].id + " - " + regionals[i].nama,
              }
              this.regionals.push(reg)
            }
          })
      this.statusProgress = false
    },
    async retrieveWitel(id) {
      this.statusProgress = true
      await witelService.getId(id)
          .then(async res => {
            await this.retrieveRegional()
            this.witel = res.data.data
          })
      this.statusProgress = false
    },
    validation() {
      if (this.witel.alias == null || this.witel.alias === '') {
        this.$refs.dlgMsg.doOpenMsg("Alias Harus Diisi")
        return false
      } else if (this.witel.nama == null || this.witel.nama === '') {
        this.$refs.dlgMsg.doOpenMsg("Nama Harus Diisi")
        return false
      } else if (this.witel.regional.id == null) {
        this.$refs.dlgMsg.doOpenMsg("Regional Harus Dipilih")
        return false
      }
      return true
    }
  },
}
</script>

<style scoped>

</style>